> ## Documentation Index
> Fetch the complete documentation index at: https://doc.lucidworks.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Post Fusion template updates using specific templateId

> Retrieve and render the template with the specified ID. All provided query parameters will be passed on to each query profile invoked during rendering.



## OpenAPI

````yaml /api-reference/5.9/fusion-api-templating.json post /renderId/{templateId}
openapi: 3.0.1
info:
  title: Fusion Templating API
  description: >-
    This API lets you perform create, read, update, and delete (CRUD) operations
    on templates and zones, and retrieve and render templates for particular
    navigation states.
  termsOfService: https://lucidworks.com/legal/developer-license-agreement/
  contact:
    name: Lucidworks
    url: https://lucidworks.com
    email: support@lucidworks.com
  license:
    name: License of API
    url: https://lucidworks.com/legal/developer-license-agreement/
  version: '5.9'
servers:
  - url: https://{FUSION_HOST.com}/api/templating
    description: Fusion
    variables:
      FUSION_HOST.com:
        default: ''
security: []
tags:
  - name: page-metadata-controller
    description: Endpoints with this tag modify page metadata.
  - name: render-controller
    description: >-
      Endpoints with this tag use the GET and POST operations to retrieve,
      render, create, read, update, and delete Fusion application templates that
      are published or in staging (unpublished).
  - name: template-settings-controller
    description: >-
      Endpoints with this tag use the GET, POST, PUT, and DELETE operations to
      create, read, update, and delete configuration information for the Fusion
      Templating service.
  - name: templates-controller
    description: >-
      Endpoints with this tag use the GET, POST, PUT, and DELETE operations to
      create, read, update, and delete Fusion application template information.
  - name: trigger-controller
    description: >-
      Endpoints with this tag use the GET and POST operations to retrieve,
      create, read, and update the Fusion application templates that are
      published or in staging (unpublished) without rendering.
  - name: zones-controller
    description: >-
      Endpoints with this tag use the GET, POST, PUT, and DELETE operations to
      retrieve, create, read, update, and delete zone information (Fusion query
      profiles).
paths:
  /renderId/{templateId}:
    parameters:
      - schema:
          type: string
          format: uuid
          example: 441eb3be-7de6-470a-8141-e416a15c7db1
        name: templateId
        in: path
        required: true
        description: The universal unique identifier (UUID) of the template.
      - schema:
          type: boolean
          default: false
        in: query
        name: showInactive
        description: >-
          The legacy parameter that is the same as the staging parameter. This
          field indicates if the request is set to retrieve published or
          unpublished (staging) templates. The default of `false` retrieves
          published templates. If set to `true`, the request retrieves
          unpublished (staging) templates.
        required: true
      - schema:
          type: boolean
          default: false
        in: query
        name: staging
        description: >-
          This field indicates if the request is set to retrieve published or
          unpublished (staging) templates. The default of `false` retrieves
          published templates. If set to `true`, the request retrieves
          unpublished (staging) templates.
        required: true
    post:
      tags:
        - render-controller
      summary: Post Fusion template updates using specific templateId
      description: >-
        Retrieve and render the template with the specified ID. All provided
        query parameters will be passed on to each query profile invoked during
        rendering.
      operationId: post-renderId-by-templateId
      requestBody:
        content:
          application/json:
            schema:
              type: object
              additionalProperties:
                type: array
                items:
                  type: string
        required: true
      responses:
        '200':
          description: OK
          content:
            '*/*':
              schema:
                $ref: '#/components/schemas/RenderResponse'
            application/x-www-form-urlencoded:
              schema:
                $ref: '#/components/schemas/RenderResponse'
        '201':
          description: Created
          content: {}
        '401':
          description: Unauthorized
          content: {}
        '403':
          description: Forbidden
          content: {}
        '404':
          description: Not Found
          content: {}
components:
  schemas:
    RenderResponse:
      title: RenderResponse
      type: object
      x-stoplight:
        id: 7af37370fa7d5
      properties:
        templateId:
          type: string
          description: >-
            The universal unique identifier (UUID) of the triggered template
            containing the rendered zones.
          format: uuid
          example: 441eb3be-7de6-470a-8141-e416a15c7db1
        rendered:
          type: array
          x-stoplight:
            id: 832wv0f60m1mh
          items:
            type: object
            x-stoplight:
              id: zfrga0ufvh5vq
            properties:
              zone:
                type: object
                description: 'Identifies the specific query profile to search. '
                x-stoplight:
                  id: ssrrp6pbi72c7
                properties:
                  name:
                    type: string
                    description: >-
                      Name of the zone that contains the specified query
                      profiles to search in the query.
                    example: Results List
                    x-stoplight:
                      id: rnpnrepb8731d
                  id:
                    type: string
                    description: The universal unique identifier (UUID) of the zone.
                    example: 6a092bd4-5098-466c-94aa-40bf68294303
                    x-stoplight:
                      id: 2rgul5pquaaw3
                    format: uuid
                  type:
                    type: string
                    description: >-
                      Read-only value that classifies the zone in the Fusion
                      Predictive Merchandiser UI. This value does not affect the
                      triggering/rendering logic. 
                    example: result-list
                    x-stoplight:
                      id: sbgz2sbc5fwy0
                  queryProfile:
                    type: string
                    description: >-
                      The query profile for this zone, that designates the
                      endpoint that is searched.
                    example: query-profile-name
                    x-stoplight:
                      id: aztjxrc9n8x4o
                  omitFilters:
                    type: boolean
                    description: >-
                      Specifies whether to include filters `fq` parameters in
                      the search. If set to `Off`, all query parameters in the
                      original request are passed on to the defined query
                      profile when a template is being rendered. If set to `On`,
                      all filters (`fq` parameters) from the original request
                      are omitted from the query to the query profile. For
                      example, if you have a category landing page where the
                      category is used to filter the displayed items, this
                      setting can allow a zone to display items outside of that
                      category (by omitting the category filter).
                    default: false
                    x-stoplight:
                      id: 79v2dm9sn1rd4
                  dirty:
                    type: boolean
                    description: >-
                      The status of the template. If `false`, the template is
                      published. If `true`, this is the staging version of this
                      template and it contains changes that have not yet been
                      published.
                    default: false
                    x-stoplight:
                      id: 45piwr1vuj8yg
                  neverPublished:
                    type: boolean
                    description: >-
                      The status of the template in the zone. If `false`, the
                      template has been published at some point. If `true`, this
                      template has never been published.
                    default: false
                    x-stoplight:
                      id: y7cibjk5w2a55
                  metadata:
                    type: object
                    description: Additional data associated with the zone.
                    x-stoplight:
                      id: b5fuszwdpvk0t
                    properties:
                      image:
                        type: string
                        description: ID for the image associated with the zone.
                        example: image-id
                        x-stoplight:
                          id: mqg5cposvelzu
                      secondary:
                        type: string
                        description: Additional text data for the zone.
                        x-stoplight:
                          id: d0jmqgei70ozd
                        example: _text_
                      primary:
                        type: string
                        description: >-
                          The unique ID for the primary metadata associated with
                          the zone.
                        x-stoplight:
                          id: qfcyby4wod3y7
                        example: primary-metadata-id
                      layout:
                        type: string
                        x-stoplight:
                          id: 5qlc5kjaar45e
                        description: >-
                          The type of layout for the template. Values include
                          grid and list.
                        example: grid
              inTemplates:
                type: array
                x-stoplight:
                  id: 5e1xuhjnxh8hd
                description: >-
                  IDs of the staging and/or published templates in which this
                  zone appears. The IDs are not displayed in any particular
                  order. The `staging` and `published` boolean fields specify if
                  that type of template ID is returned in this field.
                items:
                  type: string
                  example: >-
                    e123f4bc-5e7e-46dd-9be8-71a4f73e511a,
                    8084969c-bd23-40f7-9acf-c68d6798bec2,
                    441eb3be-7de6-470a-8141-e416a15c7db1,
                    fb148491-b39e-46d1-af33-44cd964d8ee0
              staging:
                type: boolean
                description: >-
                  Specifies if IDs are returned for staging templates associated
                  with this zone.
                x-stoplight:
                  id: m75r4xak133zn
                default: false
              published:
                type: boolean
                description: >-
                  Specifies if IDs are returned for published templates
                  associated with this zone.
                x-stoplight:
                  id: hf2e1fm8h22vc
                default: false
              layout:
                type: string
                x-stoplight:
                  id: uj342ew0i9sh7
                description: >-
                  The type of layout for the template. Values include grid and
                  list.
                example: grid
        render:
          type: object
          x-stoplight:
            id: cd0hlc67e97mh
          properties:
            response:
              type: object
              x-stoplight:
                id: p6ysdu28x70a1
              properties:
                docs:
                  type: array
                  x-stoplight:
                    id: zzc8f5ncfva67
                  description: >-
                    The document information for each document returned in the
                    query. For example:


                    "docs": [

                    {
                            "title_t": "document1 title",        
                            "score": 3.4237761
                          },
                          {
                            "title_t": "document2 title",
                            "score": 3.2169461
                          }
                        ]
                  items:
                    x-stoplight:
                      id: fbb4fudbiundj
                    type: string
                numFound:
                  type: integer
                  x-stoplight:
                    id: tr96m0ocj72x6
                  description: >-
                    The number of documents returned in the query. This field
                    can contain an exact number or an estimate. If the
                    `numFoundExact` field is set to `true`, the value in the
                    `numFound` field is an exact number. If the `numFoundExact`
                    field is set to `false`, the value in the `numFound` field
                    is an estimate and the number of documents returned is equal
                    to or greater than the value in this field.
                start:
                  type: integer
                  x-stoplight:
                    id: xh12kzcij2t65
                  description: >-
                    The number of the document in the results to display first.
                    It is offset from `document zero (0)`, which is the first
                    document in the file. For example, a value of `3` means that
                    the fourth document in the result set is the first one
                    displayed. The first three documents in the result set are
                    not displayed. A value of `0` means there is no offset, and
                    the first document in the result set is displayed first.
                maxScore:
                  type: number
                  x-stoplight:
                    id: vfu31hcosp5vm
                  description: >-
                    The score of the top document (most relevant document based
                    on the query criteria) returned in the response.
                numFoundExact:
                  type: boolean
                  x-stoplight:
                    id: 2pfn2hpqrm7qu
                  description: >-
                    This field specifies if the `numFound` field is an exact
                    number or an estimate. If `true`, the value in the
                    `numFound` field is the exact number of documents returned
                    by the query. If `false`, the value in the `numFound` field
                    is an estimate, and the number of documents returned is
                    equal to or greater than the value in that field.
        responseHeader:
          type: object
          x-stoplight:
            id: ghum9ja27lwao
          properties:
            zkConnected:
              type: boolean
              x-stoplight:
                id: 6s4p9ypssh2cm
              description: >-
                This field specifies if the node was connected to Zookeeper when
                the request was processed. If `true`, the node was connected to
                Zookeeper at the time the request was processed. If `false`, the
                node was not connected to Zookeeper at the time the request was
                processed.
            QTime:
              type: integer
              x-stoplight:
                id: s6ftbbor5tz2x
              description: >-
                The number of milliseconds for Solr to process the request. It
                calculates the time between when the request arrives and when
                the request is completed by the handler.
            totalTime:
              type: integer
              x-stoplight:
                id: t2k6xst30kqgs
              description: >-
                The number of milliseconds between when the request was received
                and the response was returned.
            params:
              type: object
              x-stoplight:
                id: mmu6d73aaykye
              properties:
                _stateVer_:
                  type: string
                  x-stoplight:
                    id: 5emdby031gsct
                  description: >-
                    The version of the application that is sending the results.
                    Because the application configuration can be changed, the
                    version used for the query is helpful information if
                    troubleshooting or investigation is necessary. The format
                    is: "your-app-name:version".
                  example: your-app-name:version
                lw.pipelineId:
                  type: string
                  x-stoplight:
                    id: benmqs1gmbh7o
                  description: The identifier of the Lucidworks pipeline used in the query.
                start:
                  type: integer
                  x-stoplight:
                    id: xfw9l1vvglq9d
                  description: >-
                    The number of the document in the results to display first.
                    It is offset from `document zero (0)`, which is the first
                    document in the file. For example, a value of `3` means that
                    the fourth document in the result set is the first one
                    displayed. The first three documents in the result set are
                    not displayed. A value of `0` means there is no offset, and
                    the first document in the result set is displayed first.
                  default: 0
                  example: 3
                params:
                  type: string
                  x-stoplight:
                    id: 8jil9ljzrp0qn
                  description: >+
                    Any parameters submitted in the request. For example, if the
                    request parameter is: `dictionary[string,array[string]]`,
                    the value in the response is:


                    "dictionary[\"key1\" : \"value1\", \"key2\" : [\"one\",
                    \"two\", \"a\", \"B\", \"bubbles\"], \"key3\" : [\"five
                    bubbles\", \"sunny\"], \"key4\" : \"value4\""

                  example: >-
                    "dictionary[\"key1\" : \"value1\", \"key2\" : [\"one\",
                    \"two\", \"a\", \"B\", \"bubbles\"], \"key3\" : [\"five
                    bubbles\", \"sunny\"], \"key4\" : \"value4\"",
                rows:
                  type: integer
                  x-stoplight:
                    id: 2qad4djdddwwt
                  description: >-
                    The number of documents to return at a time for the query.
                    For example, if the value is `10`, the number of documents
                    returned at a time is 10.
                  default: 10
                  example: 10
                version:
                  type: string
                  x-stoplight:
                    id: 0w80clznidb5t
                  description: Specifies the XML protocol version used in the response.
                  example: '2.2'
                queryProfileID:
                  type: string
                  x-stoplight:
                    id: p6yhbpjkds4oc
                  description: >-
                    The unique identifier for the query proile designated for
                    the template.
                  example: query-profile
                isFusionQuery:
                  type: boolean
                  x-stoplight:
                    id: tks73f01nviru
                  description: >-
                    This field indicates if the query originated from Fusion.
                    Fusion's Solr query stage hardcodes a default value of
                    `true`. It can be changed manually to `false` if the query
                    originates from another source, such as directly from Solr.
                    If the value is blank, the system interprets it as `false`.
                  default: true
                defType:
                  type: string
                  x-stoplight:
                    id: f8yesoljpkx8m
                  description: >-
                    The query parser Solr uses to process the `q` main query
                    parameter in the request. For example, `eDisMax` or
                    `lucene`.
                  example: eDisMax
                templateTypes:
                  type: string
                  x-stoplight:
                    id: o3rmtfehmrga6
                  description: >-
                    The type of template associated with the response. Examples
                    include landing and item-detail.
                  example: landing
                showInactive:
                  type: boolean
                  x-stoplight:
                    id: w5s7jdi91spng
                  description: >-
                    The legacy parameter that is the same as the staging
                    parameter. This field indicates if the request is set to
                    retrieve published or unpublished (staging) templates. The
                    default of `false` retrieves published templates. If set to
                    `true`, the request retrieves unpublished (staging)
                    templates.
                shards.preference:
                  type: string
                  x-stoplight:
                    id: 2mi6b6b9bjz5w
                  description: >-
                    An optional parameter for a distributed query that specifes
                    the order of precedence to sort the available replicas in
                    each shard.
                wt:
                  type: string
                  x-stoplight:
                    id: xhowda2cdrq51
                  description: >-
                    Specifies the response writer Solr uses to format the query
                    response. Values include json, csv, and xml.
                  example: json
                staging:
                  type: boolean
                  x-stoplight:
                    id: 9bwz6qhzi5y0m
                  description: >-
                    This field indicates if the request is set to retrieve
                    published or unpublished (staging) templates. The default of
                    `false` retrieves published templates. If set to `true`, the
                    request retrieves unpublished (staging) templates.
                fusionQueryId:
                  type: string
                  x-stoplight:
                    id: ln3i5htuue8y4
                  example: fusion-query-id
                  description: >-
                    The unique identifier for the Fusion query associated with
                    the results.
        status:
          type: number
          x-stoplight:
            id: 20c98pq01ik75
          description: The status of the response. A value of `0` indicates success.
          example: 0

````